import kotlin.math.*

fun main() {
    val k = readln().toInt()
    outer@ for (z in 1..k) {
        var (n, x) = readln().split(" ").map{ it.toLong() }
        for (i in 0..60) {
            if (x == 1L) {
                println(i)
                continue@outer
            }
            x = x.mulMod(x, n)
        }
        println("impossible")
    }
}

// ====================
// The code below has been thankfully copied from:
//   https://github.com/Spheniscine/AdventOfCode2019/blob/master/src/d22/main.kt
// Surely there must be a better way in Kotlin to modulo-multiply two 64-bit integers... 🙃
// ====================

infix fun Long.modulo(mod: Long) = (this % mod).let { (it shr Long.SIZE_BITS - 1 and mod) + it }

fun Long.mulMod(other: Long, m: Long): Long = _mulMod(this modulo m, other modulo m, m)

// unchecked version, assumes 0 <= a, b < m
fun _mulMod(a: Long, b: Long, m: Long): Long {
    if (m <= FLOOR_SQRT_MAX_LONG + 1) return a * b % m
    if (m < 1L shl 57) {
        val g = a.toDouble() * b / m
        return a * b - g.toLong() * m modulo m
    }
    if (m > Long.MIN_VALUE ushr 1) return _doubleAndAdd(a, b, m)
    var hi = Math.multiplyHigh(a, b) shl 1
    var lo = a * b
    if (lo < 0) {
        hi = hi or 1
        lo = lo xor Long.MIN_VALUE
    }

    return _norm(hi.shl63Mod(m) + lo % m - m, m)
}

// normalizes an integer that's within range [-MOD, MOD) without branching
inline fun _norm(it: Long, mod: Long) = (it shr Long.SIZE_BITS - 1 and mod) + it
private fun _doubleAndAdd(a: Long, b: Long, m: Long): Long {
    var res = 0L
    var b = b
    var a = a
    if(a < b) a = b.also { b = a }

    while (b > 0) {
        if (b and 1 == 1L) {
            res = _norm(res + a - m, m)
        }
        b = b shr 1
        a = _norm(a.shl(1) - m, m)
    }
    return res
}

const val FLOOR_SQRT_MAX_LONG = 3037000499L
inline val Long.numLeadingZeroes get() = java.lang.Long.numberOfLeadingZeros(this)
private fun Long.shl63Mod(m: Long): Long {
    // assumes 0 <= a < m <= 2^62
    var a = this
    var remShift = 63
    do {
        val shift = min(remShift, a.numLeadingZeroes - 1)
        a = a.shl(shift) % m
        remShift -= shift
    } while (remShift > 0)

    return a
}
