import java.io.*;
import java.util.*;

public class LeonTranscribedBufferedReader {
    public static void main(String[] args) throws IOException {
        try (BufferedReader reader = new BufferedReader(new InputStreamReader(System.in))) {
            new LeonTranscribedBufferedReader().run(reader);
        }
    }

    public void run(BufferedReader reader) throws IOException {
        int k = Integer.parseInt(reader.readLine());
        outer:
        for (int j = 0; j < k; j++) {
            String[] line = reader.readLine().split(" ");
            long n = Long.parseLong(line[0]);
            long x = Long.parseLong(line[1]);
            for (int i = 0; i < 61; i++) {
                if (x == 1) {
                    System.out.println(i);
                    continue outer;
                }
                x = modmul(x, x, n);
            }
            System.out.println("impossible");
        }
    }

    // ====================
    // The code below has been thankfully adapted from:
    //   https://github.com/Spheniscine/AdventOfCode2019/blob/master/src/d22/main.kt
    // Surely there must be a better way in Java to modulo-multiply two 64-bit integers... 🙃
    // ====================

    // unchecked version, assumes 0 <= a, b < m
    long modmul(long a, long b, long m) {
        var hi = Math.multiplyHigh(a, b) << 1;
        var lo = a * b;
        if (lo < 0) {
            hi = hi | 1;
            lo = lo ^ Long.MIN_VALUE;
        }
        return (shl63Mod(hi, m) + lo % m) % m;
    }

    long shl63Mod(long a, long m) {
        // assumes 0 <= a < m <= 2^62
        var remShift = 63;
        do {
            var shift = Integer.min(remShift, Long.numberOfLeadingZeros(a) - 1);
            a = (a << shift) % m;
            remShift -= shift;
        } while (remShift > 0);
        return a;
    }
}
