import java.io.*;
import java.util.*;

public class MaartenScanner {
    public static void main(String[] args) throws IOException {
        try (BufferedReader reader = new BufferedReader(new InputStreamReader(System.in))) {
            new MaartenScanner().run(new Scanner(reader));
        }
    }

    public void run(Scanner sc) throws IOException {
        long n = sc.nextLong();
        List<Integer> colours = new ArrayList<>((int) n);
        for (int i = 0; i < n; i++) {
            colours.add(sc.nextInt());
        }
        Collections.sort(colours);
        long ans = n * n;
        long count = 0;
        int prev = -1;
        for (int colour : colours) {
            if (colour != prev && prev != -1) {
                ans -= count * count;
                count = 0;
            }
            count += 1;
            prev = colour;
        }
        System.out.println(ans - count * count);
    }
}
