import kotlin.math.sqrt

class Point(val x: Int, val y: Int) {
    fun distanceTo(other: Point): Double = sqrt(
        (x - other.x) * 1.0 * (x - other.x) + (y - other.y) * 1.0 * (y - other.y)
    )
}
fun main() {
    val (n, _) = readInts()
    val a = List(n) { readInts().let { Point(it[0], it[1]) } }
    val dst = List(2 * n) { DoubleArray(2 * n) { Double.MAX_VALUE } }
    for (i in 0 until n) {
        for (j in 0 until n) {
            dst[i][j + n] = a[i].distanceTo(a[j])
        }
    }
    val d = DoubleArray(2 * n) { Double.MAX_VALUE }
    val p = IntArray(2 * n) { -1 }
    val used = BooleanArray(2 * n) { false }
    val paired = IntArray(2 * n) { -1 }
    d[0] = 0.0
    while (true) {
        val v = (0 until 2 * n).filter { !used[it] }.minBy { d[it] }
        if (v > n && paired[v] == -1) {
            val path = buildList {
                var x = v
                while (x != 0) {
                    add(x)
                    x = p[x]
                }
                add(0)
                reverse()
            }
            for (i in path.drop(1)) {
                if (i >= n) {
                    println(i + 1 - n)
                    System.out.flush()
                } else {
                    require(readInt() == i + 1)
                }
            }
            if (v == 2 * n - 1) break
            val pair = readInt() - 1
            paired[pair + n] = v - n
            paired[v] = pair
            dst[pair + n][v - n] = 0.0
            dst[v][pair] = 0.0
            for (i in (listOf(pair) + path.reversed())) {
                if (i < n) {
                    println(i + 1)
                    System.out.flush()
                } else {
                    require(readInt() == i + 1 - n)
                }
            }
            require(readInt() == 1)
        }
        used[v] = true
        for (u in 0 until 2 * n) {
            if (!used[u] && d[u] > dst[v][u] + d[v]) {
                d[u] = dst[v][u] + d[v]
                p[u] = v
            }
        }
    }
}

private fun readInt() = readln().toInt()
private fun readLongs() = readStrings().map { it.toLong() }
private fun readStrings() = readln().split(" ")
private fun readInts() = readStrings().map { it.toInt() }