#include <iostream>
#include <vector>
#include <numeric>
#include <array>
using namespace std;
typedef vector<int> vi;
typedef long long ll;
const int MOD = 1e9+7;

int mul(int a, int b) {
    return ll(a)*b%MOD;
}
int binpow(int a, int b) {
    int res=1;
    while(b) {
        if(b%2) res=mul(res,a);
        b/=2;
        a = mul(a,a);
    }
    return res;
}
int invmod(int v) {
    return binpow(v,MOD-2);
}

int main() {
    int n; cin >> n;
    vi fact(n+1,1),ifact(n+1);
    for(int i=2;i<=n;++i) fact[i]=mul(i,fact[i-1]);
    ifact[n]=invmod(fact[n]);
    for(int i=n-1;i>=0;--i) {
        ifact[i] = mul(i+1,ifact[i+1]);
    }
    auto ncr = [&](int a, int b) {
        if(b<0 or a<b) return 0;
        return mul(mul(fact[a],ifact[b]),ifact[a-b]);
    };
    vector<pair<int,int>> ls(n);
    vi before(n+2);
    vi after(n+2);
    for(auto& [l,s] : ls) {
        cin >> l >> s;
        before[max(l,s)]++;
        after[min(l,s)]++;
    }

    partial_sum(before.begin(),before.end(),before.begin());
    partial_sum(after.rbegin(),after.rend(),after.rbegin());
    int ans=0;
    for(auto [l,s] : ls) {
        for(auto myscore : array<int,2>{l,s}) {
            int b = before[myscore-1], a = after[myscore];
            if(min(l,s)>=myscore) --a;
            int inbetween = n-1-b-a;
            ans+=mul(ncr(inbetween,myscore-b-1), binpow(2,a+b));
            if(ans>=MOD) ans-=MOD;
        }
    }
    cout << ans << '\n';
}