#!/usr/bin/env python3
import math

n, D = map(int, input().split())
points = [None, *(tuple(map(int, input().split())) for _ in range(n))]
targets = [None] * (n + 1)

# Scout all the points in space using DFS, because we're bound to the spaceship's movement
curr = 1
stack = [1]
fuel_used = 0
fuel_stack = [0.]


def get_possible_targets(curr):
    return [
        i for i in range(2, n + 1)
        if targets[i] is None and fuel_used + math.dist(points[curr], points[i]) <= (D if i == n else D / 2)
    ]


def move_to(s):
    global curr, fuel_used
    t = int(input(f"{s}\n"))
    fuel_stack.append(math.dist(points[curr], points[s]))
    fuel_used += fuel_stack[-1]
    targets[s] = t
    targets[t] = s
    curr = t
    stack.append(t)


while True:
    possible_targets = get_possible_targets(curr)
    if not possible_targets:
        back_to_here = None
        while curr != 1:
            curr = int(input(f"{stack.pop()}\n"))
            fuel_used -= fuel_stack.pop()
            if back_to_here is not None:
                back_to_here.append(curr)
            # Save the first point with unexplored targets on our way back to the start.
            elif get_possible_targets(curr):
                back_to_here = []

        stack = [1]
        fuel_used = 0
        fuel_stack = [0.]

        # After moving back to start, move back to the first point where we still have unexplored targets.
        if back_to_here:
            for p in back_to_here[-2::-1]:
                move_to(p)

        continue

    if n in possible_targets:
        print(n)
        exit()

    move_to(possible_targets[0])
