#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;
const int MOD = 1000000007;
const int maxn = 200000;
struct ModInt{
    int x;
    ModInt(int x = 0) : x(x + (x < 0) * MOD - (x >= MOD) * MOD){}
    ModInt operator+(ModInt o) { return x + o.x; }
    ModInt operator-(ModInt o) { return x - o.x; }
    ModInt operator*(ModInt o) { return 1LL * x * o.x % MOD; }
    ModInt operator/(ModInt b) { return *this * b.inv(); }
    ModInt inv() { return pow(MOD-2); }
    ModInt pow(long long e){
        if(!e)return 1;
        ModInt r = pow(e/2); r = r * r;
        return e % 2 ? *this * r : r;
    }
    bool operator==(ModInt o) { return x == o.x; }
};

ModInt factorial[maxn + 1];

ModInt comb(int n, int k){
	if(n < k)return 0;
	if(k < 0)return 0;
	
	ModInt res = factorial[n]*(factorial[k]*factorial[n-k]).inv();
	return res;
}


int main(){
    int n;
    cin >> n;
    vector<int>l(n), s(n);
    factorial[0] = 1;
    for(int i = 1; i <= maxn; i++)factorial[i] = factorial[i-1]*i;
    for(int i = 0; i < n; i++)cin >> l[i] >> s[i];
    sort(l.begin(), l.end());
    sort(s.begin(), s.end());
    ModInt ans(0);
    for(int i = 0; i < n; i++){
        for(int j = 0; j < 2; j++){
			int t = (j == 0? s[i] : l[i]);
			int both_smaller = lower_bound(s.begin(), s.end(), t) - s.begin();
			int both_geq = n - (lower_bound(l.begin(), l.end(), t) - l.begin()) - j;
			int rest = n - both_smaller - both_geq - 1;
			ModInt res = ModInt(2).pow(both_smaller + both_geq);
			res = res * comb(rest, t-both_smaller-1);
			ans = ans + res;
		}
    }
    cout << ans.x << '\n';
}
