#include <iostream>
#include <string>
#include <vector>

int calc_ans(std::vector<std::pair<const char*, int>>& nodes) {
    if (nodes.size() < 2) return 0;

    std::vector<std::vector<std::pair<const char*, int>>> sub(26);
    
    int max1 = -1000000000, max2 = -1000000000;

    for (auto it: nodes) {
        if (it.second > 0)
            sub[it.first[0] - 'a'].push_back({it.first + 1, it.second - 1});
        else
            max1 = 0;
    }

    int res = 0;
    for (int l = 0; l < 26; l++) {
        res = std::max(res, calc_ans(sub[l]));
        int best = -1000000000;
        for (auto it: sub[l])
            best = std::max(best, it.second + 1);

        if (best > max1) {
            max2 = max1;
            max1 = best;
        } else if (best > max2)
            max2 = best;
    }

    res = std::max(res, max1 + max2);
    return res;
}

int main() {
    std::cin.tie(NULL);
    std::iostream::sync_with_stdio(false);

    int n;
    std::cin >> n;
    std::vector<std::string> str(n);
    std::vector<std::pair<const char*, int>> nodes;

    for (int i = 0; i < n; i++) {
        std::cin >> str[i];
        nodes.push_back({str[i].c_str(), str[i].size()});
    }

    std::cout << calc_ans(nodes);

    return 0;
}

