#include <vector>
#include <queue>
#include <string>
#include <iostream>

int main() {
    int w, h;

    std::cin >> w >> h;

    std::vector<std::string> matr(2 * h + 1);

    for (int i = 0; i < 2 * h + 1; i++) {
        std::cin >> matr[i];
    }
   
    for (int i = 1; i < 2 * h + 1; i += 2) {
        std::vector<int> walls;
        for (int j = 0; j < w; j++)
            if (matr[i][j] == '|')
                walls.push_back(j);

        for (int t = 0; t + 1 < walls.size(); t++) {
            int l = walls[t] + 1, r = walls[t + 1] - 1;

            bool has_ladder = false;
            for (int p = l; p <= r; p++)
                if (matr[i][p] == 'L')
                    has_ladder = true;
            for (int p = l; p <= r; p++)
                if (has_ladder && matr[i + 1][p] != '.')
                    matr[i][p] = 'L';
        }
    }

    std::queue<std::pair<int, int>> pos;
    std::vector<std::vector<bool>> visited(2 * h + 1, std::vector<bool>(w));

    pos.push({2 * h - 1, 1});
    visited[2 * h - 1][1] = true;

    while (!pos.empty()) {
        int l = pos.front().first;
        int c = pos.front().second;
        pos.pop();

        if (!visited[l][c + 1] && matr[l][c + 1] != '|') {
            visited[l][c + 1] = true;
            pos.push({l, c + 1});
        }

        if (!visited[l][c - 1] && matr[l][c - 1] != '|') {
            visited[l][c - 1] = true;
            pos.push({l, c - 1});
        }

        if (matr[l + 1][c] == '.' && !visited[l + 2][c]) {
            visited[l + 2][c] = true;
            pos.push({l + 2, c});
        }

        if (matr[l - 1][c] == '.' && matr[l][c] == 'L') {
            if (l == 1) {
                std::cout << "possible";
                return 0;
            } else if (!visited[l - 2][c]) {
                visited[l - 2][c] = true;
                pos.push({l - 2, c});
            }
        }
    }

    std::cout << "impossible";

    return 0;
}

