#include <iostream>
#include <vector>

const int MOD = 1000000007;

int add(int a, int b) {
    if (a + b >= MOD) return a + b - MOD;
    return a + b;
}

int mul(int a, int b) {
    return (long long)a * b % MOD;
}

int lgput(int b, int e) {
    int ac = 1;
    while (e > 0) {
        if (e % 2 == 1)
            ac = mul(ac, b);
        b = mul(b, b);
        e /= 2;
    }
    return ac;
}

int main() {
    int n;

    std::cin >> n;

    std::vector<int> fact(1 + n), invfact(1 + n);

    fact[0] = 1;
    for (int i = 1; i <= n; i++)
        fact[i] = mul(fact[i - 1], i);
    invfact[n] = lgput(fact[n], MOD - 2);
    for (int i = n - 1; i >= 0; --i)
        invfact[i] = mul(invfact[i + 1], i + 1);

    std::vector<int> part(1 + n + 1);
    std::vector<int> total(1 + n + 1);

    int cnt_part = 0, cnt_total = 0;

    std::vector<std::pair<int, int>> input;

    for (int i = 0; i < n; i++) {
        int a, b;
        std::cin >> a >> b;
        part[a + 1]++;
        part[b + 1]--;
        total[b + 1]++;
        input.push_back({a, b});
    }

    std::vector<int> table(1 + n);
    std::vector<int> table2(1 + n);
    for (int i = 1; i <= n; i++) {
        cnt_part += part[i];
        cnt_total += total[i];


        if (cnt_total <= i - 1) {
            int rem = i - 1 - cnt_total;

            if (rem <= cnt_part)
                table[i] = mul(mul(fact[cnt_part], invfact[rem]), invfact[cnt_part - rem]);
        
            cnt_part--;

            if (rem <= cnt_part)
                table2[i] = mul(mul(fact[cnt_part], invfact[rem]), invfact[cnt_part - rem]);

            cnt_part++;
        
            table[i] = mul(table[i], lgput(2, cnt_total + n - 1 - cnt_part - cnt_total));
            table2[i] = mul(table2[i], lgput(2, cnt_total + n - 1 - (cnt_part - 1) - cnt_total));
        }
    }

    int res = 0;
    for (int i = 0; i < n; i++) {
        res = add(res, add(table[input[i].first], table2[input[i].second]));
    }

    std::cout << res;

    return 0;
}

