/*
I started by deducting the formula for calculating the steps after i saw the pattern by running some loops without modulo.
Then I was searching for a way to make the modulo work for me, and tried some runs to see what happens and found that a limited
number of steps are needed.
I could not do the math to prove the log n steps are only needed to calculate if the target is reachable. Trial and error
and just running examples give the insight that this worked.
In a contest enverioment this won't work, since it takes to much computer time, but I hope the math students can provide the proof
or deduct the log x steps are needed.
I used a BigInter to work around the long overflows for 10e18^2.
 */

import java.math.BigInteger


fun main() {
    val k = readln().toInt()
    repeat(k) magic@{
        val (n,x) = readln().split(" ").map { it.toBigInteger() }
        var current = x
        repeat(60){
            if(current == BigInteger.ONE) {
                println(it)
                return@magic
            }
            current *=current
            current %= n
        }
        println("impossible")
    }
}

fun generateJumps() {
    var max = 0
    var missed = 0
    for(n in 2..10_000_0)  {
        var current  = n.toBigInteger()

//        print("$current")
        val seen = mutableSetOf<BigInteger>()
        var found =  false
        for(m in 1..10000) {
            current *=current
            current %= BigInteger.valueOf(1_000_000_000_000_000_000L)
            if(!seen.add(current) || current == BigInteger.ONE) {
                found = true
//                println("Found for $n convergence after $m")
                max = max.coerceAtLeast(m)
                break
            }
        }
//        if(!found) println("NO convergence foudn for $n -> $current").also { missed++ }

    }
    println(max)
    println(missed)
}

/*
5 2
next y = y + y(y-1) = y^2 - y + y = y^2
2 -> 4 -> 16 -> 256 -> 65536 -> 4294967296 -> 0 -> 0 -> 0 -> 0 -> 0
3 -> 9 -> 81 -> 6561 -> 43046721 -> 1853020188851841 -> 8733086111712066817 -> -9204772141784466943 -> -3310041070528564223 -> 2118395047680534529 -> -7087363323575676927
4 -> 16 -> 256 -> 65536 -> 4294967296 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0
5 -> 25 -> 625 -> 390625 -> 152587890625 -> 3273344365508751233 -> 7942358959831785217 -> 279109966635548161 -> -4696261158952338431 -> 8643096425819600897 -> -766971542220705791
6 -> 36 -> 1296 -> 1679616 -> 2821109907456 -> -2153214848064815104 -> 0 -> 0 -> 0 -> 0 -> 0
7 -> 49 -> 2401 -> 5764801 -> 33232930569601 -> 3475709467328330497 -> 1843124298495784449 -> 603000588348353537 -> 582341683539466241 -> -1057967576668459007 -> -552824272027426815
8 -> 64 -> 4096 -> 16777216 -> 281474976710656 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0
9 -> 81 -> 6561 -> 43046721 -> 1853020188851841 -> 8733086111712066817 -> -9204772141784466943 -> -3310041070528564223 -> 2118395047680534529 -> -7087363323575676927 -> 6615629770586038273
10 -> 100 -> 10000 -> 100000000 -> 10000000000000000 -> -8814407033341083648 -> 0 -> 0 -> 0 -> 0 -> 0
Observation 1: next y = y^2
y_0 = y^1
y_1 = y^2
y_2 = y^4
so the formula is y = y^(2^s)


we are looking to solve
y^(2^s) mod x = 1
y^2*y^s mod x = 1


Running the same steps with modulo 6
2 -> 4 -> 4 -> 4 -> 4 -> 4 -> 4 -> 4 -> 4 -> 4 -> 4
3 -> 3 -> 3 -> 3 -> 3 -> 3 -> 3 -> 3 -> 3 -> 3 -> 3
4 -> 4 -> 4 -> 4 -> 4 -> 4 -> 4 -> 4 -> 4 -> 4 -> 4
5 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1
6 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0
7 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1
8 -> 4 -> 4 -> 4 -> 4 -> 4 -> 4 -> 4 -> 4 -> 4 -> 4
9 -> 3 -> 3 -> 3 -> 3 -> 3 -> 3 -> 3 -> 3 -> 3 -> 3
10 -> 4 -> 4 -> 4 -> 4 -> 4 -> 4 -> 4 -> 4 -> 4 -> 4
mod 5
2 -> 4 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1
3 -> 4 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1
4 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1
5 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0
6 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1
7 -> 4 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1
8 -> 4 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1
9 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1
10 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0
mod 16
2 -> 4 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0
3 -> 9 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1
4 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0
5 -> 9 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1
6 -> 4 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0
7 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1
8 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0
9 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1 -> 1
10 -> 4 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0 -> 0

experimentation it seems the number converges or a solution found in 17 round for numbers upto 10e8 with 10e6 search depth or continues forever.
I can't prove it, but I'm betting that this works./
Since the input  O(n log n) solution, and the log2(20e5)= 18, i go with 36 rounds to test for safety, trial and error approach
36 gives WA on large cases, lets try log2(10e18)=60 -> works
 */