/*
This one fun. It requires a bit of logical insight and deducting. It might be wise to specify what the imply operator means.
At least in my time Logica was a 2nd year course, and to be honest I had to look up the implies operator on the internet.
I used 2 observations I made from fiddling around with formulas. The unit clause in DNF was a nice call back to my
research for my master thesis. I left my fiddling around at the bottom of the file.
 */
import kotlin.math.pow

fun main() {
    val n = readln().toInt()
    val a = readln().split(" ").map { it.toInt() == 1 }
    val lastOne = IntArray(n) { -1 }
    val precedingZeroes = IntArray(n)
    var ones = -1
    var zeroes = 0
    a.forEachIndexed { i, it ->
        if (it) {
            zeroes = 0
            ones = i
        } else zeroes++
        lastOne[i] = ones
        precedingZeroes[i] = zeroes
    }

    val q = readln().toInt()

    repeat(q) {
        val (l, r) = readln().split(" ").map { it.toInt() }
        if (a[r - 1]) {
            // Unit clause!
            println(1)
            return@repeat
        }
        var precedingR = precedingZeroes[r - 1]
        val oneL = lastOne[l - 1]
        val oneR = lastOne[r - 1]
        if (oneR == oneL && oneL != l - 1) {
            precedingR = r - l + 1
        }
        if (precedingR % 2 == 1) {
            println(0)
        } else {
            println(1)
        }
    }
}

fun compute(left: Int, right: Int, a: List<Boolean>): Boolean {
    return if (right - left == 1) (a[left - 1] imply a[right - 1])
    else compute(left, right - 1, a) imply a[right - 1]
}

/*
Logical Implication

p   q       p -> q
0   0       1
0   1       1
1   0       0
1   1       1

Transform to DNF for multiple args

!(p && !q) -> !p || q

!(!(p && !q) && !r) -> (p && !q) || r

!(!(!(p && !q) && !r) && !s) -> (!p && !r) || (q && !r) || s

!(!(!(!(p && !q) && !r) && !s) && !t) -> (p && !q && !s) || (r && !s) || t

Observation 1, if the last value is a 1, then the formula is always 1 (unit clause)

0 0  -> 1
0 0 1 -> 1
0 0 1 1 -> 1 1 1 -> 1 1 -> 1
0 0 1 1 0 -> 1110 -> 110 -> 10 -> 0
0 0 1 1 0 0-> 11100 -> 1100 -> 100 -> 00 -> 1
0 0 1 1 0 1 -> 11101 -> 1101 -> 101 -> 01 -> 1

1010 -> 010 -> 00 -> 1
100 -> 00 -> 1

10001 - 0001 - 101 - 01 - 1
100000001 - 00000001  - 1000001 - 0000001 - 100001 - 00001 - 1001 - 101 - 01 - 1

Observation 2: False alternates by the number the zeros following it  ->
implication can only be false, it the number of zeroes since the last 1 is odd

 */
infix fun Boolean.imply(q: Boolean) = !this || q
fun Boolean.toInt() = if (this) 1 else 0


// generator for testing discovery purposes
fun generateFor(n: Int) {
    for (i in 0 until 2.0.pow(n).toInt()) {
        val current = i.toString(2).padStart(n, '0').map { it == '1' }
        println("Considering $current")
        (1 until n).forEach { l ->
            (l + 1..n).forEach { r ->
                println("($l, $r) -> ${compute(l, r, current)}")
            }
        }

    }
}