#include <iostream>
#include <string>
#include <sstream>
#include <map>
#include <vector>

using namespace std;

int main() {

    int n, k; // n voters, k candidates
    cin >> n >> k;

    vector<vector<int>> battles;

    for (int i = 0; i < k; ++i)
        battles.push_back(vector<int>(k,0));

    for (int current_ballot = 0; current_ballot < n; ++current_ballot) {
        vector<int> positions(k,k);
        int v, p;
        cin >> v;
        for (int i = 0; i < v; ++i) {
           cin >> p;
           positions[p-1] = i;
        }

        for (int i = 0; i < k; ++i) {
            for (int j = i+1; j < k; ++j) {
                if (positions[i] < positions[j]) battles[i][j]++;
                else if (positions[i] > positions[j]) battles[j][i]++;
            }
        }
    }

    int winner = -1;

    for (int i = 0; i < k; i++) {
        int j = 0;
        while (j < k and (i == j or battles[i][j] > battles[j][i])) j++;
        if (j == k and winner == -1) winner = i+1;
        else if (j == k) { winner = -2; break;}
    }

    if (winner < 0) cout << "impossible" << endl;
    else cout << winner << endl;

    return 0;
}
