// O(n*k), insipired by arnoud.
#include <iostream>
#include <vector>

int n, k, v, p;
// preferences[b][c]: which preference is candidate c in ballot b
// e.g. preferences[b][c] = 0 if c appears first in b
// preferences[b][c] = k if c doesn't appear in b
std::vector<std::vector<int>> preferences;

bool is_better_than(const int a, const int b) {
    int a_beats_b = 0;
    for(int i = 0; i < n; ++i) {
        if(preferences[i][a] < preferences[i][b]) {
            ++a_beats_b;
        } else if(preferences[i][a] > preferences[i][b]) {
            --a_beats_b;
        }
    }
    return a_beats_b >= 0;
}

int main() {
    std::cin >> n >> k;

    for(int i = 0; i < n; ++i) {
        preferences.emplace_back(k + 1, k);
        std::cin >> v;
        for(int j = 0; j < v; ++j) {
            std::cin >> p;
            preferences[i][p] = j;
        }
    }

    int c = 1;
    for(int d = 2; d <= k; ++d) {
        if(is_better_than(d, c)) {
            c = d;
        }
    }
    // Now we know that if any candidate wins the election, it must be c.

    // So we check whether c beats all other candidates.
    for(int d = 1; d <= k; ++d) {
        if(c != d && is_better_than(d, c)) {
            std::cout << "impossible\n";
            return 0;
        }
    }
    std::cout << c << "\n";
}
