#include <iostream>
#include <string>
#include <unordered_map>
#include <vector>
#include <algorithm>
#include <stack>

int ans = 0;

struct Node {
	std::unordered_map<char, Node*> children;
	int height = 0;
};

// Manually done recursion, because the stack isn't big enough otherwise.
std::stack<Node*> stack;
void find_ans(Node* node) {
	if(node->children.empty()) {
		return;
	}
	if(node->children.size() == 1) {
		stack.push(node->children.begin()->second);
		return;
	}
	auto children_heights = std::vector<int>();
	for(auto [_, child] : node->children) {
		children_heights.push_back(child->height + 1);
		stack.push(child);
	}
	std::ranges::sort(children_heights);
	std::ranges::reverse(children_heights);
	ans = std::max(ans, children_heights[0] + children_heights[1]);
}

int main() {
	std::cin.tie(nullptr);
	std::iostream::sync_with_stdio(false);

	int n;
	std::cin >> n;

	auto root = Node();

	for(int i = 0; i < n; ++i) {
		std::string s;
		std::cin >> s;

		// Add word to trie.
		// Can't do recursion here because g++ didn't recognize the tail recursion.
		char* word = s.data();
		int word_size = s.size();
		auto node = &root;
		for(;;) {
			if(word_size == 0) {
				auto empty_node = new Node();
				empty_node->height = -1;
				node->children[' '] = empty_node;
				break;
			}
			if(node->children.contains(word[0])) {
				node->height = std::max(node->height, word_size);
				node = node->children[word[0]];
				word++;
				word_size--;
				continue;
			}
			auto new_child = new Node();
			new_child->height = word_size - 1;
			node->children[word[0]] = new_child;
			node->height = std::max(node->height, new_child->height + 1);
			word++;
			word_size--;
			node = new_child;
		}
	}

	stack.push(&root);
	while(!stack.empty()) {
		auto node = stack.top();
		stack.pop();
		find_ans(node);
	}

	std::cout << ans << "\n";
}

/*
3
amsterdam
is
amazing

3
bbb
abbba
aaba

2
abcdefghijklmnopqrstuvwxyz
abcdefghijklmnopqrstuvwxyz

2
a
a

*/