#include <vector>
#include <queue>
#include <string>
#include <iostream>
#include <set>

using namespace std;

int main(void) {
    int w;
    int h;
    cin >> w >> h;
    vector<string> grid;
    vector<vector<bool>> hasladder;
    for (int i=0; i<2*h+1; ++i) {
        string s;
        cin >> s;
        grid.push_back(s);
        if (i%2 == 1) {
            vector<bool> hasladder_i(w, false);
            int lastwall = 0;
            bool hasladder_current = false;
            for (int idx=0; idx<w; ++idx) {
                char c = s[idx];
                if (c == '|') { 
                    lastwall = idx;
                    hasladder_current = false;
                } else if (hasladder_current) {
                    hasladder_i[idx] = true;
                } else if (c == 'L' && !hasladder_current) {
                    hasladder_current = true;
                    for (int j=lastwall+1; j<idx+1; ++j)
                        hasladder_i[j] = true;
                }
            }
            hasladder.push_back(hasladder_i);
        }
    }
    
    set<pair<int, int>> visited;
    visited.insert(make_pair(1, 2*h-1));
    queue<pair<int, int>> q;
    q.push(make_pair(1, 2*h-1));
    while (!q.empty()) {
        pair<int, int> p = q.front(); q.pop();
        int x = p.first;
        int y = p.second;
        if (y == 0 && grid[y][x] == '.') {
            cout << "possible\n";
            return 0;
        }        
        if (grid[y][x] == '|' || grid[y][x] == '-') continue;
        vector<pair<int, int>> nextp{make_pair(x-1, y), make_pair(x+1, y), make_pair(x, y+1)};
        if (y%2 == 0 || hasladder[y/2][x]) nextp.push_back(make_pair(x, y-1));
        for (auto p: nextp) {
            if (visited.count(p) == 0) {
                q.push(p);
                visited.insert(p);
            }
        }
    }
    cout << "impossible\n";
    return 0;
}
