#!/usr/bin/env python3
import heapq
import sys

def dijkstra(n, points, wormhole):
    q = [(0, 0)]
    prev = [-1]*n
    dist = [10**9]*n
    dist[0] = 0
    while q:
        du, u = heapq.heappop(q)
        if u != 0 and wormhole[u] == -1:
            return u, prev
        if du > dist[u]: continue
        uold = u
        if u != 0: 
            u = wormhole[u]
            if dist[u] < dist[uold]: continue
            else: dist[u] = dist[uold]
        pu = points[u]
        for idx, p in enumerate(points):
            distp_new = dist[u] + ((p[0]-pu[0])**2+(p[1]-pu[1])**2)**0.5
            if distp_new < dist[idx]:
                heapq.heappush(q, (distp_new, idx))
                prev[idx] = uold
                dist[idx] = distp_new
                

n, d = [int(x) for x in input().split()]
points = [tuple([int(x) for x in input().split()]) for _ in range(n)]
wormhole = [-1]*n
while True:
    u, prev = dijkstra(n, points, wormhole)
    seq = []
    last = u
    while last != 0:
        seq.append(last)
        last = prev[last]
    seq.reverse()
    for s in seq:
        print(s+1)
        sys.stdout.flush()
        if s+1 == n: exit()
        a = int(input())-1
    wormhole[u] = a
    wormhole[a] = u
    seq.reverse()
    for s in seq:
        print(wormhole[s]+1)
        sys.stdout.flush()
        input()
    print(1)
    sys.stdout.flush()
    input()
    
