#!/usr/bin/env python3
# @EXPECTED_RESULTS@: RUN_TIME_ERROR, WRONG_ANSWER
# Dijkstra is overkill for this problem, but should probably still be accepted.
import heapq
import re

w, h = map(int, input().split())
grid = [
    re.sub(r"\.*L\.*", lambda m: "L" * len(m.group(0)), input())  # Replace dots around 'L' with only ladders
    for _ in range(2 * h + 1)
]
queue = [(0, 2, 2 * h - 1)]
cost = [[1e9 for _ in range(w + 1)] for _ in range(2 * h + 2)]
cost[2 * h - 1][2] = 0

while queue:
    curr, x, y = heapq.heappop(queue)
    for xx, yy in [(x + 1, y), (x, y + 1), (x - 1, y), (x, y - 2)]:
        if (grid[y][x], grid[y - 1][x]) == ("L", ".") if yy == y - 2 else grid[yy][xx] in ".L":
            if yy == -1:
                print("possible")
                exit()
            if curr + 1 < cost[yy][xx]:
                cost[yy][xx] = curr + 1
                heapq.heappush(queue, (curr + 1, xx, yy))

print("impossible")
