// @EXPECTED_RESULTS@: WRONG_ANSWER, RUN_TIME_ERROR, TIME_LIMIT_EXCEEDED
import java.util.*

fun main() {
    val trie = TrieNode('^')
    System.`in`.bufferedReader().lineSequence().drop(1)
        .forEach { add(trie, "^$it$") }
    println(trie.find())
}

fun add(base: TrieNode, raw: String) {
    var trie = base
    var word = raw
    while (true) {
        word = word.substring(1)
        trie.words.add(word)
        if (trie.leaf) {
            if (trie.unprocessed.isEmpty()) {
                trie.unprocessed = word
                return
            }
            trie.leaf = false
            trie.children[word.first()] = TrieNode(word)

            if (trie.unprocessed.first() != word.first()) {
                trie.children[trie.unprocessed.first()] = TrieNode(trie.unprocessed)
                return
            }
            word = trie.unprocessed
            trie = trie.children[trie.unprocessed.first()]!!

            continue
        }
        if (trie.children.containsKey(word.first())) {
            trie = trie.children[word.first()]!!
            continue
        } else {
            trie.children[word.first()] = TrieNode(word)
            return
        }
    }
}

data class TrieNode(
    val value: Char,
    var leaf: Boolean = true,
    val children: MutableMap<Char, TrieNode> = mutableMapOf(),
    var unprocessed: String = "",
    val words: PriorityQueue<String> = PriorityQueue { o1, o2 -> o2.length.compareTo(o1.length) }
) {
    constructor(word: String) : this(word.first()) {
        unprocessed = word.substring(1)
        words.add(unprocessed)
    }


    fun find(): Int {
        if (leaf) {
            return unprocessed.length
        }
        if (children.size == 1) {
            return children[children.keys.first()]!!.find()
        }
        //special case
        if(children.containsKey('$')) {
            val left = children.filter { it.key != '$' }
            if(left.size == 1) {
                return left[left.keys.first()]!!.words.peek().length
            }
            return left.maxOf { it.value.find()}
//            best = left.values.map { it.words.peek().length }.sortedDescending().let { (l1, l2) -> l1 + l2 - 2}.coerceAtLeast(best)
//            return left.values.map { it.find() }.max().coerceAtLeast(best)
        }

        // find leaf childeren
//        val leaves = children.values.filter { it.leaf }
//        var best = -1
//        if(leaves.size >= 2) {
//            best = children.values.map { it.unprocessed.length  }.sortedDescending().let { (l1,l2)  -> l1 + l2 }
//        }
//        println("$this.value ${children.values.map { it.find() }.sortedDescending()}}")

        val best = children.values.map { it.words.peek().length }.sortedDescending().let { (l1, l2) -> l1 + l2 - 2}

        return children.values.map { it.find() }.max().coerceAtLeast(best)
    }
}