// @EXPECTED_RESULTS@: RUN_TIME_ERROR, TIME_LIMIT_EXCEEDED
import java.util.*

fun main() {
    val trie = TrieNode('$')
    System.`in`.bufferedReader().lineSequence().drop(1)
        .forEach { trie.add("^$it$") }
    println(trie.find())
}

data class TrieNode(
    val value: Char,
    var leaf: Boolean = true,
    val children: MutableMap<Char, TrieNode> = mutableMapOf(),
    var unprocessed: String = "",
    val words: PriorityQueue<String> = PriorityQueue { o1, o2 -> o2.length.compareTo(o1.length) }
) {
    fun add(raw: String) : Int{
        val word = raw.substring(1)
        words.add(word)
        if(leaf ) {
            if(unprocessed.isEmpty()) {
                unprocessed = word
                return 0
            }
            leaf = false
            children[word.first()] = TrieNode(word.first())
            children[word.first()]!!.add(word)
            if(unprocessed.first()!=word.first()){
                children[unprocessed.first()] = TrieNode(unprocessed.first())
            }
            children[unprocessed.first()]!!.add(unprocessed)
            if(children.keys.size == 1) return 1
            return  0
        }
        if(children.containsKey(word.first())) {
            return 1 +  children[word.first()]!!.add(word)
        } else {
            children[word.first()] = TrieNode(word.first())
            children[word.first()]!!.add(word)
            return 0
        }
    }

    fun find(): Int{
        if(leaf) {
            return unprocessed.length
        }
        if(children.size == 1) {
            return children[children.keys.first()]!!.find()
        }
        // find leaf childeren
        val leaves = children.values.filter { it.leaf }

        val best = children.values.map { it.words.peek().length }.sortedDescending().let { (l1,l2)  -> l1 + l2 }

        return  children.values.map { it.find() }.max().coerceAtLeast(best)
    }
}