import java.util.concurrent.ConcurrentHashMap

fun main() {
    val n = readln().toInt()
    val a = readln().split(" ").map { it.toInt() == 1 }
    val q = readln().toInt()
    val cache = mutableMapOf<Pair<Int, Int>, Boolean>()
    fun compute(left: Int, right: Int): Boolean {
        return if (cache.containsKey(left to right)) cache[left to right]!!
        else if (right - left == 1) (a[left - 1] imply a[right - 1]).also { cache[left to right] = it }
        else (compute(left, right - 1) imply a[right - 1]).also { cache[left to right] = it }
    }
    repeat(q) {
        val (l, r) = readln().split(" ").map { it.toInt() }
        println(compute(l, r).toInt())
    }
}

/*
Logical Implication

p   q       p -> q
0   0       1
0   1       1
1   0       0
1   1       1
 */
infix fun Boolean.imply(q: Boolean) = !(this && !q)
fun Boolean.toInt() = if (this) 1 else 0
