import java.util.*

fun main() {
    val (w, h) = readln().split(" ").map { it.toInt() }
    val jail = System.`in`.bufferedReader().readLines()
    val finish = -1 to 0..w
    val labels = mutableListOf(finish)
    val connections = mutableMapOf(finish to mutableListOf<Node>())
    val search = mutableMapOf(-1 to mutableListOf(0..w))
    connections[finish] = mutableListOf()
    for (row in 1..2 * h step 2) {
        val line = jail[row]
        val up = jail[row - 1]
        var index = 1
        while (index < w) {
            if (line[index] == WALL) {
                index++
                continue
            }
            val start = index
            var hasLadder = false
            while (line[index] != WALL) {
                hasLadder = hasLadder || line[index] == LADDER
                index++
            }
            val end = index - 1
            val label = row to start..end
            connections[label] = mutableListOf()
            search.putIfAbsent(row, mutableListOf())
            search[row]!!.add(start..end)
            labels.add(label)
            val upConnection =
                up.withIndex().drop(start).take(end - start + 1).filter { it.value == EMPTY }.map { it.index }
            val upperRooms =
                search[row - 2]!!.filter { range -> upConnection.any { it in range } }.map { row - 2 to it }
            upperRooms.forEach { connections[it]!!.add(label) }
            if (hasLadder) {
                connections[label]!!.addAll(upperRooms)
            }
        }
    }
    val start = h * 2 - 1 to search[h * 2 - 1]!!.first()

    val startState = Triple(h * 2 - 1, start, setOf(start))
    val queue = PriorityQueue<Triple<Int, Node, Set<Node>>> { o1, o2 -> o1.first.compareTo(o2.first) }
    val visisted = mutableSetOf(start)
    queue.add(startState)
    while (queue.isNotEmpty()) {
        val (level, label, seen) = queue.remove()
        if (level == -1) {
            println("possible")
            return
        }
        val next = connections[label]!!.filter { it !in seen }
        next.map { Triple(it.first, it, seen + mutableSetOf(it)) }
            .filter { visisted.add(it.second) }
            .toCollection(queue)
    }
    println("impossible")
}
typealias Node = Pair<Int, IntRange>

const val WALL = '|'
const val EMPTY = '.'
const val LADDER = 'L'