// O(n*k^4)
#include <iostream>
#include <string>
#include <vector>
#include <sstream>
#include <algorithm>
#include <cassert>

template<typename T>
std::string to_string(const std::vector<T>& v) {
    std::stringstream s;
    s << "[";
    bool first = true;
    for(T t : v) {
        if(first) {
            first = false;
        } else {
            s << ", ";
        }
        s << t;
    }
    s << "]";
    return s.str();
}

template<typename T>
std::ostream& operator<< (std::ostream& out, const std::vector<T>& v) {
    return out << to_string(v);
}

const int MAXK = 100;
int matchups[MAXK][MAXK];
bool cand[MAXK];
bool DEBUG = false;

std::vector<std::vector<int>> ballots;

int get_matchup(int c, int d) {
    int ans = 0;
    for(auto ballot : ballots) {
        /*auto c_it = std::find(ballot.begin(), ballot.end(), c);
        auto d_it = std::find(ballot.begin(), ballot.end(), d);*/
        int c_it = ballot.size(), d_it = ballot.size();
        bool flag_c = false, flag_d = false;
        for(int i = 0; i < ballot.size(); ++i) {
            for(int j = i; j < ballot.size(); ++j) {
                if(ballot[i] == d) {
                    flag_d = true;
                }
                if(ballot[i] == c) {
                    flag_c = true;
                    if (ballot[j] == d) {
                        ++ans;
                        goto cont;
                    }
                }
            }
            /*if(ballot[i] == c) {
                c_it = i;
            }
            if(ballot[i] == d) {
                d_it = i;
            }*/
        }
        if(flag_d) {
            --ans;
        } else if(flag_c) {
            ++ans;
        }
        /*if(c_it < d_it) {
            ++ans;
        } else if(c_it > d_it) {
            --ans;
        }*/
        cont:
            static_cast<void> (0); //no op
    }
    return ans;
}

int main() {
    int n, k, v, p;
    std::cin >> n >> k;
    for(int i = 0; i < n; ++i) {
        std::cin >> v;
        auto ballot = std::vector<int>();
        for(int j = 0; j < v; ++j) {
            std::cin >> p;
            ballot.push_back(p - 1);
        }

        for(int j = 0; j < k; ++j) {
            cand[j] = true;
        }

        ballots.push_back(ballot);

        /*for(auto &&a : ballot) {
            cand[a] = false;
            for(int j = 0; j < k; ++j) {
                if(cand[j]) {
                    //std::cout << a + 1 << " wins against " << j + 1 << std::endl;
                    int c = a, d = j;
                    ++matchups[c][d];
                    --matchups[d][c];
                }
            }
        }*/
    }

    if(DEBUG) {
        for(int i = 0; i < k; ++i) {
            for(int j = 0; j < k; ++j) {
                std::cout << matchups[i][j] << " ";
            }
            std::cout << std::endl;
        }

        for(int i = 0; i < k; ++i) {
            for(int j = 0; j < k; ++j) {
                std::cout << get_matchup(i, j) << " ";
            }
            std::cout << std::endl;
        }
    }

    for(int i = 0; i < k; ++i) {
        bool b = true;
        for(int j = 0; j < k; ++j) {
            int m = get_matchup(i, j);
            //assert(m == matchups[i][j]);
            if(i != j) {
                if(m <= 0) {
                    b = false;
                    break;
                }
            }
        }
        if(b) {
            std::cout << i + 1 << std::endl;
            return 0;
        }
    }
    std::cout << "impossible" << std::endl;
}
/*
6 4
1 2
2 4 3 1
3 2 4
4 1
4
4 2 3

6 4
1 2
2 4 3 1
3 4 2
4 1
4
4 3 2
*/
