#include <vector>
#include <queue>
#include <string>
#include <iostream>
#include <set>

using namespace std;

int main(void) {
    int w;
    int h;
    cin >> w >> h;
    vector<string> grid;
    for (int i=0; i<2*h+1; ++i) {
        string s;
        cin >> s;
        grid.push_back(s);
    }
    
    set<pair<int, int>> visited;
    visited.insert(make_pair(1, 2*h-1));
    queue<pair<int, int>> q;
    q.push(make_pair(1, 2*h-1));
    while (!q.empty()) {
        pair<int, int> p = q.front(); q.pop();
        int x = p.first;
        int y = p.second;
        if (y == 0 && grid[y][x] == '.') {
            cout << "possible\n";
            return 0;
        }        
        if (grid[y][x] == '|' || grid[y][x] == '-') continue;
        vector<pair<int, int>> nextp{make_pair(x-1, y), make_pair(x+1, y), make_pair(x, y+1)};
        if (y%2 == 0) nextp.push_back(make_pair(x, y-1));
        else {
            int xl = x;
            while (grid[y][xl] == '.') xl -= 1;
            if (grid[y][xl] == 'L')
                nextp.push_back(make_pair(x, y-1));
            else {
                int xr = x;
                while (grid[y][xr] == '.')
                    xr += 1;
                if (grid[y][xr] == 'L')
                    nextp.push_back(make_pair(x, y-1));
            }
        }
        for (auto p: nextp) {
            if (visited.count(p) == 0) {
                q.push(p);
                visited.insert(p);
            }
        }
    }
    cout << "impossible\n";
    return 0;
}
