#!/usr/bin/env python3
# Based on accepted/maarten-dijkstra.py, but mistakenly thinks that a ladder can be used to drill a hole in the ceiling.
import heapq

w, h = map(int, input().split())
grid = [input() for _ in range(2 * h + 1)]
queue = [(0, 1, 2 * h - 1)]
cost = [[1e9 for _ in range(w + 1)] for _ in range(2 * h + 2)]
cost[2 * h - 1][1] = 0

while queue:
    curr, x, y = heapq.heappop(queue)
    for xx, yy in [(x + 1, y), (x, y + 1), (x - 1, y), (x, y - 2)]:
        if grid[y][x] == "L" if yy == y - 2 else grid[yy][xx] in ".L":
            if yy == -1:
                print("possible")
                exit()
            if curr + 1 < cost[yy][xx]:
                cost[yy][xx] = curr + 1
                heapq.heappush(queue, (curr + 1, xx, yy))

print("impossible")
