#include <iostream>
#include <vector>

using namespace std;

vector<int> tree;

bool impl(bool a, bool b) {
    return !a || b;
}

int merge(int a, int b) {
    if (a == -1) return b;
    if (b == -1) return a;
    return impl(a, b);
}

void build(vector<int>& a, int v, int vl, int vr) {
    if (vr - vl == 1) {
        tree[v] = a[vl];
        return;
    }
    int m = (vl + vr) / 2;
    build(a, 2 * v, vl, m);
    build(a, 2 * v + 1, m, vr);
    tree[v] = merge(tree[2 * v], tree[2 * v + 1]);
}

int get(int l, int r, int v, int vl, int vr) {
    if (vl >= r || vr <= l) {
        return -1;
    }
    if (vl >= l && vr <= r) {
        return tree[v];
    }
    int m = (vl + vr) / 2;
    return merge(get(l, r, 2 * v, vl, m), get(l, r, 2 * v + 1, m, vr));
}

int main() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    tree.resize(4 * n);
    build(a, 1, 0, n);
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int l, r;
        cin >> l >> r;
        --l;
        cout << get(l, r, 1, 0, n) << "\n";
    }
    return 0;
}