#include <iostream>
#include <string>
#include <vector>
#include <sstream>

template<typename T>
std::string to_string(const std::vector<T>& v) {
    std::stringstream s;
    s << "[";
    bool first = true;
    for(T t : v) {
        if(first) {
            first = false;
        } else {
            s << ", ";
        }
        s << t;
    }
    s << "]";
    return s.str();
}

template<typename T>
std::ostream& operator<< (std::ostream& out, const std::vector<T>& v) {
    return out << to_string(v);
}

const int MAXK = 1000;
int matchups[MAXK][MAXK];
bool cand[MAXK];
bool DEBUG = false;

int main() {
    int n, k, v, p;
    std::cin >> n >> k;
    for(int i = 0; i < n; ++i) {
        std::cin >> v;
        auto ballot = std::vector<int>();
        for(int j = 0; j < v; ++j) {
            std::cin >> p;
            ballot.push_back(p - 1);
        }

        for(int j = 0; j < k; ++j) {
            cand[j] = true;
        }

        for(auto &&a : ballot) {
            cand[a] = false;
            for(int j = 0; j < k; ++j) {
                if(cand[j]) {
                    //std::cout << a + 1 << " wins against " << j + 1 << std::endl;
                    int c = a, d = j;
                    if(d > c) {
                        std::swap(c, d);
                    }
                    if(c == a) {
                        ++matchups[c][d];
                        --matchups[d][c];
                    } else {
                        --matchups[c][d];
                        ++matchups[d][c];
                    }
                }
            }
        }
    }

    if(DEBUG) {
        for(int i = 0; i < k; ++i) {
            for(int j = 0; j < k; ++j) {
                std::cout << matchups[i][j] << " ";
            }
            std::cout << std::endl;
        }
    }

    for(int i = 0; i < k; ++i) {
        bool b = true;
        for(int j = 0; j < k; ++j) {
            if(i != j) {
                if(matchups[i][j] <= 0) {
                    b = false;
                    break;
                }
            }
        }
        if(b) {
            std::cout << i + 1 << std::endl;
            return 0;
        }
    }
    //std::cout << "impossible" << std::endl;
}
